Package org.jcsp.awt

# Class ActiveLabel

java.lang.Object
java.awt.Component
java.awt.Label
org.jcsp.awt.ActiveLabel

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Accessible`, `CSProcess`

public class ActiveLabel extends Label implements CSProcess
``java.awt.Label`` with a channel interface.

## Process Diagram

## Description

`ActiveLabel` is a process extension of `java.awt.Label` with channels for run-time configuration and event notification. The event channels should be connected to one or more application-specific server processes (instead of registering a passive object as a Listener to this component).

All channels are optional. The `configure` channel is settable from a constructor. Event channels can be added to notify the occurrence of any type of `Event` the component generates (by calling the appropriate `add` XXX `EventChannel` method before the process is run). Messages can be sent down the `configure` channel at any time to configure the component. See the table below for details.

All channels are managed by independent internal handler processes. It is, therefore, safe for a serial application process both to service an event channel and configure the component -- no deadlock can occur.

IMPORTANT: it is essential that event channels from this process are always serviced -- otherwise the Java Event Thread will be blocked and the GUI will stop responding. A simple way to guarantee this is to use channels configured with overwriting buffers. For example:

       final One2OneChannel myMouseEvent = Channel.one2one (new OverWriteOldestBuffer (n));

       final ActiveLabel myLabel = new ActiveLabel ("Look at Me");
       myContainer.addMouseEventChannel (myMouseEvent.out ());

This will ensure that the Java Event Thread will never be blocked. Slow or inattentive readers may miss rapidly generated events, but the `n` most recent events will always be available.

## Channel Protocols

Input Channels
configure | String | Change the label on the `ActiveLabel` to the value of the `String`

Boolean

1. If this is the `Boolean.TRUE` object, the label is made active
2. If this is the `Boolean.FALSE` object, the label is made inactive
3. Other `Boolean` objects are ignored

ActiveLabel.Configure | Invoke the user-defined `Configure.configure` method on the label.
Output Channels
componentEvent | ComponentEvent | See the ``addComponentEventChannel`` method.
focusEvent | FocusEvent | See the ``addFocusEventChannel`` method.
keyEvent | KeyEvent | See the ``addKeyEventChannel`` method.
mouseEvent | MouseEvent | See the ``addMouseEventChannel`` method.
mouseMotionEvent | MouseEvent | See the ``addMouseMotionEventChannel`` method.

## Example

     import java.awt.*;
     import org.jcsp.lang.*;
     import org.jcsp.util.*;
     import org.jcsp.awt.*;

     public class ActiveLabelExample {

       public static void main (String argv[]) {

         final Frame root = new Frame ("ActiveLabel Example");

         final int nLabels = 8;
         final int countdown = 10;

         final One2OneChannel[] configureLabel = Channel.one2oneArray (nLabels);

         final ActiveLabel[] label = new ActiveLabel[nLabels];
         for (int i = 0; i invalid input: '<' label.length; i++) {
           label[i] = new ActiveLabel (configureLabel[i].in (), "==>  " + countdown + "  invalid input: '<'==");
           label[i].setAlignment (Label.CENTER);
         }

         final One2OneChannel configureButton = Channel.one2one ();
         final One2OneChannel event = Channel.one2one (new OverWriteOldestBuffer (10));

         final ActiveButton button = new ActiveButton (configureButton.in (), event.out (), "Start");

         root.setSize (300, 200);
         root.setLayout (new GridLayout (3, 3));
         for (int i = 0; i invalid input: '<' nLabels + 1; i++) {
           if (i invalid input: '<' 4) {
             root.add (label[i]);
           } else if (i == 4) {
             root.add (button);
           } else if (i > 4) {
             root.add (label[i - 1]);
           }
         }
         root.setVisible (true);

         new Parallel (
           new CSProcess[] {
             new Parallel (label),
             button,
             new CSProcess () {
               public void run () {
                 final long second = 1000;
                 CSTimer tim = new CSTimer ();
                 Alternative alt = new Alternative (new Guard[] {event.in (), tim});
                 event.in ().read ();              // wait for the start signal
                 configureButton.out ().write ("Restart");
                 int count = countdown;
                 long timeout = tim.read () + second;
                 while (count > 0) {
                   tim.setAlarm (timeout);
                   switch (alt.priSelect ()) {
                     case 0:                 // reset signal
                       event.in ().read ();        // clear the reset
                       timeout = tim.read () + second;
                       count = countdown;
                     break;
                     case 1:                 // timeout signal
                       timeout += second;
                       count--;
                     break;
                   }
                   final String newLabel = "==>  " + count + "  invalid input: '<'==";
                   for (int i = 0; i invalid input: '<' nLabels; i++) {
                     configureLabel[i].out ().write (newLabel);
                   }
                 }
                 root.setVisible (false);
                 System.exit (0);
               }
             }
           }
         ).run ();

       }

     }

Author:
  P.D. Austin and P.H. Welch
See Also:
  - `Label`
  - `ComponentEvent`
  - `FocusEvent`
  - `KeyEvent`
  - `MouseEvent`
  - `OverWriteOldestBuffer`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`ActiveLabel.Configure`
This enables general configuration of this component.

## Nested classes/interfaces inherited from class java.awt.Label

`Label.AccessibleAWTLabel`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

### Fields inherited from class java.awt.Label

`CENTER, LEFT, RIGHT`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

## Constructor Summary

Constructors
Constructor
Description
`ActiveLabel()`
Constructs a new `ActiveLabel` with no label or configuration channel.
`ActiveLabel(String s)`
Constructs a new `ActiveLabel` with no configuration channel.
`ActiveLabel(ChannelInput configure)`
Constructs a new `ActiveLabel` with no initial label.
`ActiveLabel(ChannelInput configure, String s)`
Constructs a new `ActiveLabel`.

## Method Summary

Modifier and Type
Method
Description
`void`
`addComponentEventChannel(ChannelOutput componentEvent)`
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred.
`void`
`addFocusEventChannel(ChannelOutput focusEvent)`
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred.
`void`
`addKeyEventChannel(ChannelOutput keyEvent)`
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred.
`void`
`addMouseEventChannel(ChannelOutput mouseEvent)`
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred.
`void`
`addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)`
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred.
`void`
`run()`
The main body of this process.
`void`
`setConfigureChannel(ChannelInput configure)`
Sets the configuration channel for this `ActiveLabel`.

### Methods inherited from class java.awt.Label

`addNotify, getAccessibleContext, getAlignment, getText, paramString, setAlignment, setText`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ActiveLabel

public ActiveLabel()
Constructs a new `ActiveLabel` with no label or configuration channel.

### ActiveLabel

public ActiveLabel(String s)
Constructs a new `ActiveLabel` with no configuration channel.

Parameters:
  `s` - the initial string displayed on the label.

### ActiveLabel

public ActiveLabel(ChannelInput configure)
Constructs a new `ActiveLabel` with no initial label.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.

### ActiveLabel

public ActiveLabel(ChannelInput configure, String s)
Constructs a new `ActiveLabel`.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.
  `s` - the initial string displayed on the label.

## Method Details

### setConfigureChannel

public void setConfigureChannel(ChannelInput configure)
Sets the configuration channel for this `ActiveLabel`. This method overwrites any configuration channel set in the constructor.

Parameters:
  `configure` - the channel for configuration events -- can be null if no configuration is required.

### addComponentEventChannel

public void addComponentEventChannel(ChannelOutput componentEvent)
Add a new channel to this component that will be used to notify that a `ComponentEvent` has occurred. This should be used instead of registering a ComponentListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `componentEvent` - the channel down which to send ComponentEvents.

### addFocusEventChannel

public void addFocusEventChannel(ChannelOutput focusEvent)
Add a new channel to this component that will be used to notify that a `FocusEvent` has occurred. This should be used instead of registering a FocusListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `focusEvent` - the channel down which to send FocusEvents.

### addKeyEventChannel

public void addKeyEventChannel(ChannelOutput keyEvent)
Add a new channel to this component that will be used to notify that a `KeyEvent` has occurred. This should be used instead of registering a KeyListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `keyEvent` - the channel down which to send KeyEvents.

### addMouseEventChannel

public void addMouseEventChannel(ChannelOutput mouseEvent)
Add a new channel to this component that will be used to notify that a `MouseEvent` has occurred. This should be used instead of registering a MouseListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseEvent` - the channel down which to send MouseEvents.

### addMouseMotionEventChannel

public void addMouseMotionEventChannel(ChannelOutput mouseMotionEvent)
Add a new channel to this component that will be used to notify that a `MouseMotionEvent` has occurred. This should be used instead of registering a MouseMotionListener with the component. It is possible to add more than one channel by calling this method multiple times If the channel passed is `null`, no action will be taken.

NOTE: This method must be called before this process is run.

Parameters:
  `mouseMotionEvent` - the channel down which to send MouseMotionEvents.

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`